/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { DependencyProperty } from "igniteui-react-core/ES2015/DependencyProperty";
import { ConsolidatedItemsPosition_$type } from "./ConsolidatedItemsPosition";
import { Type, runOn, enumGetBox, markType, fromEnum } from "igniteui-react-core/ES2015/type";
import { Pool$1 } from "igniteui-react-core/ES2015/Pool$1";
import { List$1 } from "igniteui-react-core/ES2015/List$1";
import { ScalerParams } from "./ScalerParams";
import { Rectangle } from "igniteui-react-core/ES2015/Rectangle";
import { PropertyMetadata } from "igniteui-react-core/ES2015/PropertyMetadata";
import { isNaN_, isInfinity } from "igniteui-react-core/ES2015/number";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
export class ColumnSeries extends HorizontalAnchoredCategorySeries {
    constructor() {
        super();
        this.qc = null;
        this.p7 = 0;
        this.ab = ColumnSeries.$;
        this.pq = 2;
    }
    bf() {
        return new ColumnSeriesView(this);
    }
    ii(a) {
        super.ii(a);
        this.p6 = a;
    }
    m4() {
        return 1;
    }
    get_nj() {
        return true;
    }
    get nj() {
        return this.get_nj();
    }
    preferredCategoryMode(a) {
        return this.pq;
    }
    li(a) {
        if (this.qc == null) {
            this.qc = runOn(this, this.p9);
        }
        let b = this.pt != null ? this.pt : this.yAxis;
        let c = this.pn;
        return this.os.c$d(this, a, c, b, this.mv, this.nv(this.bi), this.nw(this.bi), this.qc);
    }
    de(a, b) {
        if (this.dh(a, b)) {
            return true;
        }
        if (this.ls(a, b)) {
            return true;
        }
        return false;
    }
    hl(a, b) {
        super.hl(a, b);
        let c = b;
        if (a && c.c5 != null) {
            c.c5.count = 0;
        }
    }
    eb() {
        return this.pn.jj(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi));
    }
    ob(a, b) {
        super.ob(a, b);
        let c = a.f;
        if (!b.q()) {
            return;
        }
        let d = b.bq;
        let e = b.bp;
        let f = this.getEffectiveViewport1(b);
        let g = new ScalerParams(0, d, e, this.pt.b8, f);
        let h = new ScalerParams(0, d, e, this.pn.b8, f);
        let i = this.pt;
        let j = i.dt(i.j6, g);
        let k = this.pn.jj(d, e, f);
        let l = this.pn;
        let m = b;
        if (isNaN_(k) || isInfinity(k)) {
            m.c5.count = 0;
            return;
        }
        this.m2.x(this, this.nn(), this.pn, runOn(this, this.mo), this.nv(b), this.nw(b));
        this.m2.p = this.qa;
        this.m2.q = this.qb;
        this.m2.j = this.qa;
        this.m2.k = this.qb;
        let n = false;
        let o = this.m2.c;
        if (o != null) {
            n = true;
        }
        let p = this.pn.cc;
        let q = p ? this.pn : null;
        let r = this.valueColumn.count;
        let s = this.nv(b);
        let t = 0;
        for (let u = 0; u < c.count; ++u) {
            let v = c._inner[u][0] - 0.5 * k;
            let w = this.p9(c._inner[u]);
            let x = j;
            w = Math.max(w, -100);
            x = Math.min(x, e.bottom + 100);
            let y = Math.abs(x - w);
            if (isInfinity(y)) {
                continue;
            }
            let z = m.c5.item(t);
            t++;
            z.width = k;
            z.height = y;
            if (n) {
                this.n7(c, u, r, l, h, b.n);
            }
            if (z.dataContext != null) {
                let aa = z.dataContext;
                if (s == 1) {
                    let ab = this.m2.a(r, u)[0];
                    if (ab >= 0 && ab < this.bz.count) {
                        if (q != null && q.i$b != null && q.i$b.count > ab) {
                            ab = q.i$b._inner[ab];
                        }
                        aa.item = this.bz.item(ab);
                    }
                }
                else {
                    aa.item = null;
                }
            }
            this.m2.ae(z, false, false, false, false);
            z.al = this.m2.j;
            z.am = this.m2.k;
            m.da(z, v, Math.min(x, w));
        }
        m.c5.count = t;
        b.cs(a);
    }
    get p8() {
        return this.p7;
    }
    set p8(a) {
        if (this.p8 != a) {
            let b = this.p8;
            this.p7 = a;
            this.raisePropertyChanged("ConsolidatedColumnVerticalPosition", enumGetBox(ConsolidatedItemsPosition_$type, b), enumGetBox(ConsolidatedItemsPosition_$type, this.p8));
        }
    }
    p9(a) {
        if (a == null || a.length < 3) {
            return NaN;
        }
        switch (this.p8) {
            case 0: return a[1];
            case 1: return a[2];
            case 2: return (a[1] + a[2]) / 2;
            case 3:
                let b = (a[1] + a[2]) / 2;
                if (this.yAxis == null) {
                    return b;
                }
                let c = this.yAxis.dw(b, new ScalerParams(1, this.bs.my, this.bs.mx, this.yAxis.b8));
                if (c < this.yAxis.j6) {
                    return a[2];
                }
                else {
                    return a[1];
                }
            case 4:
                let d = (a[1] + a[2]) / 2;
                let e = this.yAxis.dw(d, new ScalerParams(1, this.bs.my, this.bs.mx, this.yAxis.b8));
                if (this.yAxis == null) {
                    return d;
                }
                if (e < this.yAxis.j6) {
                    return a[1];
                }
                else {
                    return a[2];
                }
            default: return (a[1] + a[2]) / 2;
        }
    }
    get useHighMarkerFidelity() {
        return this.nq;
    }
}
ColumnSeries.$t = markType(ColumnSeries, 'ColumnSeries', HorizontalAnchoredCategorySeries.$);
Type.dep(DependencyProperty, PropertyMetadata, ColumnSeries, 'raisePropertyChanged', ['RadiusX:qa:qg', [1, 2], 'RadiusY:qb:qh', [1, 2]]);
export class ColumnSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c4 = null;
        this.c6 = null;
        this.db = new Rectangle();
        this.c5 = null;
        this.c4 = a;
        this.c5 = ((() => {
            let $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(this, this.dc);
            $ret.activate = runOn(this, this.c7);
            $ret.disactivate = runOn(this, this.c9);
            $ret.destroy = runOn(this, this.c8);
            return $ret;
        })());
    }
    ap() {
        super.ap();
        this.c6 = new List$1(Rectangle.$, 0);
        if (!this.n) {
            this.e.eo = 4;
            this.e.bj = 1;
        }
    }
    dc() {
        let a = new Rectangle();
        this.c6.add(a);
        a._visibility = 1;
        return a;
    }
    c7(a) {
        a._visibility = 0;
    }
    c9(a) {
        a._visibility = 1;
    }
    c8(a) {
        this.c6.remove(a);
    }
    da(a, b, c) {
        if (!this.isDirty) {
            this.an();
        }
        a.o = c;
        a.n = b;
    }
    z(a) {
        return this.c6._inner[a];
    }
    y(a) {
        let b = this.c6._inner[a];
        this.db._visibility = b._visibility;
        this.db.n = b.n;
        this.db.o = b.o;
        this.db.width = b.width;
        this.db.height = b.height;
        let c = this.bl(a);
        this.db._fill = c;
        this.db._stroke = c;
        this.db.ac = this.e.es + 3;
        return this.db;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            for (let c = 0; c < this.c6.count; c++) {
                let d = this.x(c, b);
                this.ba(d, c, b);
                a.v(d);
            }
        }
    }
    ai(a) {
        super.ai(a);
        let b = 0;
        let c = new List$1(Rectangle.$, 0);
        for (let d of fromEnum(this.c5.a)) {
            c.add(d);
        }
        c.aa((e, f) => {
            if (e.n < f.n) {
                return -1;
            }
            else if (e.n > f.n) {
                return 1;
            }
            else {
                return 0;
            }
        });
        for (let e of fromEnum(c)) {
            this.e.a2.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
        }
        b++;
    }
}
ColumnSeriesView.$t = markType(ColumnSeriesView, 'ColumnSeriesView', AnchoredCategorySeriesView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.ColumnSeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.ColumnSeries" />*/
